#!/bin/sh

port=`/sbin/cfg -a r net.conf WAN "RTSP Port"`

start() {
	echo -n "Starting rtsp:"
	/sbin/rtspd -p $port
}

stop() {
	kill `pidof rtspd`
}

restart() {
	stop
	start
}

case "$1" in
	start)
		start
		;;
	stop)
		stop
		;;
	restart)
		restart
		;;
	*)
		echo $"Usage $0 {start|stop|restart}"
		exit 1
esac

exit $?
